#include "project.h"
#include <stdio.h>
#include "FPS_Utils.h"
#include "utils.h"

extern char str[] ; /* print buffer */

int wait_finger_touch(void)
{
    int result = 0 ;
#if 0
    while(fps_is_finger_pressed() == 0) {
        CyDelay(100) ;
    }
#else
    while(ICPCK_Read() == 0) {
        CyDelay(10) ;
    }
#endif
    return( result ) ;
}

int wait_finger_release(void)
{
    int result = 0 ;
#if 0
    while(fps_is_finger_pressed()) {
        CyDelay(100) ;
    }
#else
    while(ICPCK_Read()) {
        CyDelay(10) ;
    }
#endif
    return( result ) ;
}

int FPS_Open(int extra_info) 
{
    int result ;
    print("OPEN command : ") ;
    result = fps_open(extra_info) ; /* request extra info */
    if (result == CMD_ACK) {
        result = 0 ;
        print("OK\n") ;
    } else if (result == CMD_NACK) {
        print("Nack Recieved\n") ;
    }
    return( result ) ;
}

int FPS_Close(void)
{
    int result ;
    print("CLOSE Command : ") ;
    result = fps_close() ;
    if (result == CMD_ACK) {
        result = 0 ;
        print("OK\n") ;
    } else if (result == CMD_NACK) {
        print("Nack Recieved\n") ;
    }
    return( result ) ;
}

int FPS_Baudrate(int baud)
{
    int result ;
    sprintf(str, "Change Baudreate to %d\n", baud) ;
    print(str) ;
    result = fps_change_baudrate(baud) ; 
    if (_res_packet.response == CMD_ACK) {
        result = 0 ;
        print("OK\n") ;
    } else if (_res_packet.response == CMD_NACK) {
        print("Nack Recieved\n") ;
    }
    return(result) ;
}

int FPS_FastSearch(void) 
{
    int result ;
    print("Fast Search : ") ;
    result = fps_first_search() ;
    if (result == CMD_ACK) {
        result = 0 ;
        print("OK\n") ;
    } else if (result == CMD_NACK) {
        print("Nack Recieved\n") ;
    }
    return( result ) ;
}

int FPS_EnrollAFingerAt(int id) 
{
    int result = 0 ;

    sprintf(str, "Enroll a Finger at ID[%d]\n", id) ;
    print(str) ;
    result = fps_start_enrollment(id, 0) ; /* not checking duplication */
    CyDelay(100) ;
    OK_OR_RETURN ;
    
    print("Release your finger : ") ;
    wait_finger_release() ;
    print("released\n") ;
    
    print("Touch the finger to enroll : ") ;
    wait_finger_touch() ;
    print("touched\n") ;
    LED_ON ;
    CyDelay(100) ;
    
    print("Capturing the finger ") ;
    result = fps_capture_finger(1) ; /* best image */
    OK_OR_RETURN ;
    CyDelay(100) ;
    
    print("Enroll 1 ") ;
    result = fps_enroll1() ;
    OK_OR_RETURN ;
    CyDelay(100) ;
    
    LED_OFF ;
    CyDelay(100) ;
    print("Release your finger : ") ;
    wait_finger_release() ;
    print("released\n") ;

   
    print("Touch the finger to enroll : ") ;
    wait_finger_touch() ;
    print("touched\n") ;
    LED_ON ;
    CyDelay(100) ;
    
    print("Capturing the finger ") ;
    result = fps_capture_finger(1) ; /* best image */   
    OK_OR_RETURN ;
    CyDelay(100) ;
    print("Enroll 2 ") ;
    result = fps_enroll2() ;
    OK_OR_RETURN ;
    CyDelay(100) ;
    
    LED_OFF ;
    print("Release your finger : ") ;
    wait_finger_release() ;
    print("released\n") ;

    print("Touch the finger to enroll : ") ;
    wait_finger_touch() ;
    print("touched\n") ;
    LED_ON ;    
    
    print("Capturing the finger ") ;
    CyDelay(100) ;
    result = fps_capture_finger(1) ; /* best image */  
    OK_OR_RETURN ;
    CyDelay(100) ;
    
    print("Enroll 3 ") ;
    result = fps_enroll3() ;
    CyDelay(100) ;
    OK_OR_RETURN ;
    LED_OFF ;
        
    return( result ) ;
}

/* [] END OF FILE */
